* Program ...: Encrypt.PRG
* Author ....: Clay Carley
* Date ......: February 1, 1986
* Note(s) ...: This command file encrypts numeric and
*              character memory variables.
*
* All input and output variables are passed as parameters.
*
* Input is:
*
*   mvar     = variable to be encrypted
*   width    = the width of the variable 
*   decimals = number of digits to the right of the decimal 
* 		     place, otherwise not used and set to 0 
*              for character-type variables.
*
* Output is:
*
*   outvar   = character-type encrypted output
*
PARAMETERS mvar, width, decimals, outvar
* ---The engine or "heart" of the encryptor.
DO CASE
   CASE TYPE( "mvar" ) = "C"
        * ---This will encrypt a character type variable
        * ---and uses the ASCII code of the first character
        * ---to encrypt the rest of the character string.
        enc     = ASC( mvar )
        outvar  = SUBSTR( mvar,1,1 ) 
        chcount = 2 
        DO WHILE chcount <= width
            temp    = ASC( SUBSTR( mvar,chcount,1 ) ) 
            outvar  = outvar + CHR( enc + temp ) 
            chcount = chcount + 1
        ENDDO
   CASE TYPE( "mvar" ) = "N"
        * ---This will convert all of the digits in a number
        * ---to ASCII values using the first converted digit's
        * ---ASCII value to encrypt the variable into a 
        * ---character string.
        temp    = STR( mvar,width,decimals )
        enc     = ASC( temp )
        outvar  = SUBSTR( temp,1,1 )
        chcount = 2
        DO WHILE chcount <= LEN( temp )
            outvar  = outvar +;
                     CHR( enc + ASC( SUBSTR( temp,chcount,1 ) ) )
            chcount = chcount + 1
        ENDDO 
    OTHERWISE
	   * ---A data-type error has occurred.
        CLEAR
        @ 5,5 SAY "ERROR in data type. Cannot be encrypted."
        WAIT
ENDCASE
RETURN
* EOP Encrypt.PRG
